#include <stdio.h>
#include <string.h>
#include <math.h>

void calculateSquareEquation(float a, float b, float c, float* x1, float* x2) {
    float D;
    D = b * b - 4 * a * c;
    if (a == 0) {
        *x1 = -c / b;
    }
    else if (D > 0) {
        *x1 = (-b + sqrt(D)) / (2 * a);
        *x2 = (-b - sqrt(D)) / (2 * a);
    }
    else if (D == 0) {
        *x1 = -b / (2 * a);
    }    
}

void SLU(float a, float b, float c, float a1, float b1, float c1, float* x1, float* x2) {
    
        float d;
        d = a * b1 - a1 * b;
        if (d)
        {
            *x1 = (c * b1 - c1 * b) / d;
            *x2 = (a * c1 - a1 * c) / d;
        }

}

void inputData(int a,int* f, float* a1, float* b1, float* c1, float* a2, float* b2, float* c2)
{
    char buf[100];
    switch (a) {
    case 1:
        for (;;)
        {
            for (;;)
            {
                printf("\n a: ");
                if (fgets(buf, sizeof buf, stdin) == NULL) {
                    printf("Input closed\n");
                    break;
                }
                int n;
                if (sscanf_s(buf, "%f %n", a1, &n) == 1 && buf[n] == '\0')
                {
                    break;
                }
                printf("<%s>   1 .   \n", buf);
            }
            for (;;)
            {
                printf(" b: ");
                if (fgets(buf, sizeof buf, stdin) == NULL) {
                    printf("Input closed\n");
                    break;
                }
                int n;
                if (sscanf_s(buf, "%f %n", b1, &n) == 1 && buf[n] == '\0')
                {
                    break;
                }
                printf("<%s>   1 .   \n", buf);
            }
            for (;;)
            {
                printf(" c: ");
                if (fgets(buf, sizeof buf, stdin) == NULL) {
                    printf("Input closed\n");
                    break;
                }
                int n;
                if (sscanf_s(buf, "%f %n", c1, &n) == 1 && buf[n] == '\0')
                {
                    break;
                }
                printf("<%s>   1 .   \n", buf);
            }
            if (*a1 == 0 && *b1 == 0)
            {
                printf("     ,   ", buf);
            }
            else
            {
                break;
            }
        }
        break;
    case 2:
        for (;;)
        {
            printf(" a1: ");
            if (fgets(buf, sizeof buf, stdin) == NULL) {
                printf("Input closed\n");
                break;
            }
            int n;
            if (sscanf_s(buf, "%f %n", a1, &n) == 1 && buf[n] == '\0')
            {
                break;
            }
            printf("<%s>   1 .   \n", buf);
        }
        for (;;)
        {
            printf(" b1: ");
            if (fgets(buf, sizeof buf, stdin) == NULL) {
                printf("Input closed\n");
                break;
            }
            int n;
            if (sscanf_s(buf, "%f %n", b1, &n) == 1 && buf[n] == '\0')
            {
                break;
            }
            printf("<%s>   1 .   \n", buf);
        }
        for (;;)
        {
            printf(" c1: ");
            if (fgets(buf, sizeof buf, stdin) == NULL) {
                printf("Input closed\n");
                break;
            }
            int n;
            if (sscanf_s(buf, "%f %n", c1, &n) == 1 && buf[n] == '\0')
            {
                break;
            }
            printf("<%s>   1 .   \n", buf);
        }
        for (;;)
        {
            printf(" a2: ");
            if (fgets(buf, sizeof buf, stdin) == NULL) {
                printf("Input closed\n");
                break;
            }
            int n;
            if (sscanf_s(buf, "%f %n", a2, &n) == 1 && buf[n] == '\0')
            {
                break;
            }
            printf("<%s>   1 .   \n", buf);
        }
        for (;;)
        {
            printf(" b2: ");
            if (fgets(buf, sizeof buf, stdin) == NULL) {
                printf("Input closed\n");
                break;
            }
            int n;
            if (sscanf_s(buf, "%f %n", b2, &n) == 1 && buf[n] == '\0')
            {
                break;
            }
            printf("<%s>   1 .   \n", buf);
        }
        for (;;)
        {
            printf(" c2: ");
            if (fgets(buf, sizeof buf, stdin) == NULL) {
                printf("Input closed\n");
                break;
            }
            int n;
            if (sscanf_s(buf, "%f %n", c2, &n) == 1 && buf[n] == '\0')
            {
                break;
            }
            printf("<%s>   1 .   \n", buf);
        }
        break;
    case 3:

        for (;;)
        {
            for (;;)
            {
                printf(" a: ");
                if (fgets(buf, sizeof buf, stdin) == NULL) {
                    printf("Input closed\n");
                    break;
                }
                int n;
                if (sscanf_s(buf, "%d %n", f, &n) == 1 && buf[n] == '\0')
                {
                    break;
                }
                printf("<%s>    .   \n", buf);
            }
            if (*f < 0)
            {
                printf("   ,   \n");
            }
            else
            {
                break;
            }
        }
        break;
    }
}

void GetData(int a,int f, float x1, float x2)
{
    switch (a) {
    case 1:
        if (x1 != 0 && x2 != 0)
        {
            printf("  x1 = %f x2 = %f", x1,x2);
        }
        else if(x1 != 0)
        {
            printf("  x = %f", x1);
        }
        else
        {
            printf(" ");
        }
        break;
    case 2:
        if (x1 == 0 && x2 == 0)
        {
            printf("   ");
        }
        else
        {
            printf("X  %f Y  %f", x1, x2);
        }
        break;
    case 3:
        if (f == 0)
        {
            printf("  1", f);
        }
        else printf("  %d", f);
        break;
    }
}

void Factorial(int* f)
{
    int x, xF, d;
    xF = *f;
    x = xF;
    for (d = 1;d < x;d++)
    {
        xF = xF * (x - d);
    }
    *f = xF;
}

void main() 
{
    system("chcp 1251");
    float a1, b1, c1, a2, b2, c2, x1 = 0, x2 = 0;
    int a,f = 0;
    char buf[100];
    printf("  : \n");
    printf("1.  . \n");
    printf("2.    . \n");
    printf("3.  (). \n");
    for (;;) 
    {
        if (fgets(buf, sizeof buf, stdin) == NULL) {
            printf("Input closed\n");
            break;
        }
        int n;
        if (sscanf_s(buf, "%d %n", &a, &n) == 1 && buf[n] == '\0' && a >= 1 && a <=3)
        {
            break;
        }
        printf("<%s>    .   .\n", buf);
    }
    switch (a) {
    case 1:
        inputData(a,&f, &a1, &b1, &c1, &a2, &b2, &c2);
        calculateSquareEquation(a1, b1, c1, &x1, &x2);
        GetData(a,f, x1, x2);
        break;
    case 2:
        inputData(a, &f, &a1, &b1, &c1, &a2, &b2, &c2);
        SLU(a1, b1, c1, a2, b2, c2, &x1, &x2);
        GetData(a, f, x1, x2);
        break;
    case 3:
        inputData(a, &f, &a1, &b1, &c1, &a2, &b2, &c2);
        Factorial(&f);
        GetData(a,f, x1, x2);
        break;
    }
}